--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateFrame = CreateFrame("frame","DCoordsUpdateFrame");
--DCoordsUpdateFrame:RegisterEvent("ADDON_LOADED");
DCoordsUpdateFrame:RegisterEvent("VARIABLES_LOADED");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED");
--DCoordsUpdateFrame:RegisterEvent("PLAYER_LOGOUT");

-- MAIN UPDATE
DCoordsUpdateFrame:SetScript("OnUpdate", function(self) DCoordsUpdateHandler() end);

DCoordsUpdateFrame:SetScript("OnEvent", function(self,event,addonName)
	--log(event);
	if (event == "ADDON_LOADED") then
		if (addonName == "DCoords") then
			log("DCoords v"..DCoordsVersion.." ADDON_LOADED!");
			DCoordsGVar["DCZone"] = GetZoneText();
			DCoordsGVar["DCSubZone"] = GetSubZoneText();
			DCoordsGVar["DCLoaded"] = true;
		end
	elseif (event == "VARIABLES_LOADED") then
		log("DCoords v"..DCoordsVersion.." VARIABLES_LOADED!");
		DCoordsGVar["DCVarsLoaded"] = true;
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		DCoordsInit();
		--DCoordsUpdateFrame:SetScript("OnEvent",nil);
	elseif (event == "ZONE_CHANGED") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "ZONE_CHANGED_NEW") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "ZONE_CHANGED_NEW_AREA") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	elseif (event == "ZONE_CHANGED_INDOORS") then
		--toChat("DCoords: Event [" .. event .. "]");
		DCoordsGVar["DCZone"] = GetZoneText();
		DCoordsGVar["DCSubZone"] = GetSubZoneText();
		minimapSetFont();
	else
		--log("DCoords: WARNING: Unhandled event: [" .. event .. "]");
	end
end);
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function showOptions()
	log("showOptions()");
	playClick();
	InterfaceOptionsFrame_OpenToCategory(DCoordsGVar["DCOptions"].Main.name); -- will open interface menu
	InterfaceOptionsFrame_OpenToCategory(DCoordsGVar["DCOptions"].Other.name); -- will  expand of sub options of DCoords
	InterfaceOptionsFrame_OpenToCategory(DCoordsGVar["DCOptions"].Main.name); -- will select main DCoords entry
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsSlashCommandHandler(cmd)
	log("DCoordsSlashCommandHandler(): " .. cmd);
	
	if (cmd == nil or cmd == "" or string.find(cmd, "help") ~= nil) then
		log(" ");
		log("DCoords v" .. DCoordsVersion .. " slash commands:");
		log("  /DC menu - show menu");
		log("  /DC show  - show coordinates");
		log("  /DC hide - hide coordinates");
		log("  /DC reset - reset position and settings");
		return;
	end
	
	strSearchResult = string.find(cmd,"reset");
	if (strSearchResult ~= nil) then
		log("DCoords attempting to reset positions...");
		reset();
		return;
	end
	
	if (cmd == "menu") then
		showOptions();
		return;
	end
	
	if (cmd == "show menu") then
		showOptions();
		return;
	end
		
	if (cmd == "show") then
		DCoordsDBZ["MainBar"].visible = true;
		mainBarSetVisibility();
		return;
	end
	
	if (cmd == "hide") then
		DCoordsDBZ["MainBar"].visible = false;
		mainBarSetVisibility();
		return;
	end


	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsInit()
	log("DCoordsInit()");
	
		
	-- Remove the cancel button
	InterfaceOptionsFrameCancel:Hide()
	InterfaceOptionsFrameOkay:SetAllPoints(InterfaceOptionsFrameCancel)

	-- Make clicking cancel the same as clicking okay
	InterfaceOptionsFrameCancel:SetScript("OnClick", function()
		InterfaceOptionsFrameOkay:Click()
	end)	
	
	-- Ensure vars are ok
	--DCoordsDBZ = nil;

	-- One time calls
	SetMapToCurrentZone(); -- Works anyway but could be another addon doing that
	
	-- Init
	initOptions();
	initWorldMapCoordinates();
	initObjectiveTracker();
	initMainBar();
	initMinimapCoordinates();
	

		
	mainBarSetVisibility();
	mainBarSetBackground();
	mainBarSetFont();
	mainBarSetPosition();

	
	
	-- Setup slash commands
	SlashCmdList["DCoordsCOMMAND"] = DCoordsSlashCommandHandler;
	SLASH_DCoordsCOMMAND1 = "/dc";
	
	-- Message
	toChat(" ");
	toChat("DCoords v"..DCoordsVersion);
	toChat("DCoords: To view DCoords settings right click coordinates bar");
	toChat("DCoords: To drag DCoords hold SHIFT + LEFT CLICK then DRAG.");
	toChat("DCoords: To reset DCoords type /DC reset.");
	
	-- DCoords is ready
	DCoordsGVar["DCReady"] = true;
	
	
	wait(3,delayedCalls);
	
	
	
	-- EXTRAS
	
	
	--showOptions();

	
	--[[
	local a = MinimapZoneTextButton:GetChildren();
	local b = MinimapCluster:GetChildren();
	
	
	
	
	for k,v in pairs(b) do
		--print(v:GetName());
	end
	
	
	--local kids = { Minimap:GetChildren() };
	local kids = { MinimapCluster:GetChildren() };
	
	local function myTest(frame)
		frame:Hide();
		return frame:GetName();
	end
	
	for key,child in ipairs(kids) do
		local retOK, ret1 = pcall(myTest,child);
		print(ret1);
		
	end
	--]]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Some things just dont work unless we delay!
function delayedCalls()
	log("delayedCalls()");
	initMinimapCoordinates();
	mainBarSetPosition();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


local waitTable = {};
local waitFrame = nil;

function wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end






function logTable(tbl)
	for k, v in pairs( tbl ) do
		--print(v);
		print( type(v) .. ": " .. tostring(v));
		if (type(v) == "table") then
			logTable(v)
		end
	end
end

function logTable2(tbl)
	for k, v in pairs( tbl ) do
		if (type(v) == "table") then
			print(v);
		else
			print(v)
		end
	end
end




--[[
-- EXPERIEMENTAL REFERENCES
local oo = _G["MinimapZoneTextButton"];
oo:Hide();	
	
	
--]]




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function reset()
	log("reset()");
	initVars();
	PlaySound("QUESTADDED");
    ReloadUI();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
