--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
initMainBar = function()
    log("initMainBar()");
    
    local frameAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["MainBar"].alignmentIndex ];
    local textJustification = DCoordsGVar["JustificationOptions"][ DCoordsDBZ["MainBar"].fontSelectedJustificationIndex ];
    
    log("initMainBar(): frameAlignment = " .. frameAlignment);
    log("initMainBar(): textJustification = " .. textJustification);
    
    --DCoordsDBZ["MainBar"].x = 0;
    --DCoordsDBZ["MainBar"].y = 0;
    
    -- Frame
	--DCoordsGVar["DCMainBarFrameName"] = "DCoordsMainBar" .. tostring(math.random(99999999));
	DCoordsGVar["DCMainBar"] = CreateFrame("frame","DCoordsMainBar",DCoordsUIP);
    DCoordsGVar["DCMainBar"]:SetFrameStrata("HIGH");
    DCoordsGVar["DCMainBar"]:EnableMouse(false);
	DCoordsGVar["DCMainBar"]:SetResizable(true);
	DCoordsGVar["DCMainBar"]:SetMovable(true);
    DCoordsGVar["DCMainBar"]:SetWidth(500);
    DCoordsGVar["DCMainBar"]:SetHeight(200);
    
    DCoordsGVar["DCMainBar"]:ClearAllPoints(true);
    DCoordsGVar["DCMainBar"]:SetPoint(frameAlignment,15,20);
    DCoordsGVar["DCMainBar"]:ClearAllPoints(true);
    DCoordsGVar["DCMainBar"]:SetPoint(frameAlignment,DCoordsDBZ["MainBar"].x,DCoordsDBZ["MainBar"].y);
    --DCoordsGVar["DCMainBar"]:SetPoint("BOTTOMLEFT",DCoordsDBZ["MainBar"].x,DCoordsDBZ["MainBar"].y);
    
    
    
    -- Frame text
    --DCoordsGVar["DCMainBarText"] = DCoordsGVar["DCMainBar"]:CreateFontString("DCMainBarText", "OVERLAY", "GameTooltipText");
    --function createLabel(name,frameContainer,text,size,r,g,b,a,justify,x,y)
    DCoordsGVar["DCMainBarText"] = createLabel("DCMainBarText",DCoordsGVar["DCMainBar"],"DLL",14,1,1,1,1,"LEFT",0,0);
    
    --local textAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["MainBar"].fontAlignmentIndex ];
    --DCoordsGVar["DCMainBarText"]:SetPoint("BOTTOMLEFT",DCoordsGVar["DCMainBar"],"BOTTOMLEFT",0,0);
    --DCoordsGVar["DCMainBarText"]:SetPoint("LEFT",0,0);
    DCoordsGVar["DCMainBarText"]:SetPoint(textJustification,ox,oy);
    DCoordsGVar["DCMainBarText"]:SetJustifyH("LEFT");
    
    
    
	DCoordsGVar["DCMainBarText"]:SetFont(getMainFrameFont(), DCoordsDBZ["MainBar"].fontSize,"OUTLINE");
	DCoordsGVar["DCMainBarText"]:SetShadowOffset(1, -1);
	DCoordsGVar["DCMainBarText"]:SetTextColor(
        DCoordsDBZ["MainBar"].fontR,
        DCoordsDBZ["MainBar"].fontG,
        DCoordsDBZ["MainBar"].fontB,
        DCoordsDBZ["MainBar"].fontA
    );
	DCoordsGVar["DCMainBarText"]:SetNonSpaceWrap(false);
	DCoordsGVar["DCMainBarText"]:SetText(DCoordsTempText);
	
    --DCoordsGVar["DCMainBarText"]:SetJustifyH(        DCoordsGVar["AlignmentTypes"][DCoordsDBZ["MainBarTextSelectedAlignment"]]    );
    
    DCoordsGVar["DCMainBar"]:Hide();
    DCoordsGVar["DCMainBar"]:Show();
    
    -- Init bg texture
    DCoordsGVar["DCMainBar"].texture = DCoordsGVar["DCMainBar"]:CreateTexture (nil, "background");
    DCoordsGVar["DCMainBar"].texture:SetColorTexture(
        DCoordsDBZ["MainBar"].bgR,
        DCoordsDBZ["MainBar"].bgG,
        DCoordsDBZ["MainBar"].bgB,
        DCoordsDBZ["MainBar"].bgA
    );
    DCoordsGVar["DCMainBar"]:SetWidth(10);
	DCoordsGVar["DCMainBar"]:SetHeight(10);
    
    -- On mouse up handler
    DCoordsGVar["DCMainBar"]:SetScript("OnMouseUp", function(self,buttonIdentifier) mainBarMouseUpHandler(self,buttonIdentifier) end);
    
    
    -- Drag
    DCoordsGVar["DCMainBar"]:RegisterForDrag("LeftButton");
	
	DCoordsGVar["DCMainBar"]:SetScript("OnDragStart", function(self)
		if (IsShiftKeyDown()) then
			log("DCoords: Drag started!"); 
			self:StartMoving();
		end 
	end);
	
	DCoordsGVar["DCMainBar"]:SetScript("OnDragStop", function(self)
        DCoordsDragEnd(self);
        if (IsShiftKeyDown()) then
            
        end
	end);
    

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsDragEnd()
    log("DCoordsDragEnd()");
    local selectedAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["MainBar"].alignmentIndex ];
    local DCoordsMainBar = DCoordsGVar["DCMainBar"];

    if (selectedAlignment == "TOPLEFT") then
        DCoordsDBZ["MainBar"].x = DCoordsMainBar:GetLeft(); 
        DCoordsDBZ["MainBar"].y = 0 - (GetScreenHeight() - DCoordsMainBar:GetTop());
    elseif (selectedAlignment == "LEFT") then
        DCoordsDBZ["MainBar"].x = DCoordsMainBar:GetLeft(); 
        DCoordsDBZ["MainBar"].y = (DCoordsMainBar:GetTop()-(DCoordsMainBar:GetHeight()/2)) - (GetScreenHeight()/2);
    elseif (selectedAlignment == "BOTTOMLEFT") then
        DCoordsDBZ["MainBar"].x = DCoordsMainBar:GetLeft(); 
        DCoordsDBZ["MainBar"].y = (DCoordsMainBar:GetTop() - DCoordsMainBar:GetHeight());
    elseif (selectedAlignment == "TOP") then
        DCoordsDBZ["MainBar"].x = DCoordsMainBar:GetLeft() - (GetScreenWidth()/2) + (DCoordsMainBar:GetWidth()/2);
        DCoordsDBZ["MainBar"].y = 0 - (GetScreenHeight() - DCoordsMainBar:GetTop());
    elseif (selectedAlignment == "CENTER") then
        DCoordsDBZ["MainBar"].x = DCoordsMainBar:GetLeft() - (GetScreenWidth()/2) + (DCoordsMainBar:GetWidth()/2);
        DCoordsDBZ["MainBar"].y = (DCoordsMainBar:GetTop()-(DCoordsMainBar:GetHeight()/2)) - (GetScreenHeight()/2);
    elseif (selectedAlignment == "BOTTOM") then
        DCoordsDBZ["MainBar"].x = DCoordsMainBar:GetLeft() - (GetScreenWidth()/2) + (DCoordsMainBar:GetWidth()/2);
        DCoordsDBZ["MainBar"].y = (DCoordsMainBar:GetTop() - DCoordsMainBar:GetHeight());
    elseif (selectedAlignment == "TOPRIGHT") then
        DCoordsDBZ["MainBar"].x = 0 - (GetScreenWidth() - DCoordsMainBar:GetLeft()) + DCoordsMainBar:GetWidth();
        DCoordsDBZ["MainBar"].y = 0 - (GetScreenHeight() - DCoordsMainBar:GetTop());
    elseif (selectedAlignment == "RIGHT") then
        DCoordsDBZ["MainBar"].x = 0 - (GetScreenWidth() - DCoordsMainBar:GetLeft()) + DCoordsMainBar:GetWidth();
        DCoordsDBZ["MainBar"].y = (DCoordsMainBar:GetTop()-(DCoordsMainBar:GetHeight()/2)) - (GetScreenHeight()/2);
    elseif (selectedAlignment == "BOTTOMRIGHT") then
        DCoordsDBZ["MainBar"].x = 0 - (GetScreenWidth() - DCoordsMainBar:GetLeft()) + DCoordsMainBar:GetWidth();
        DCoordsDBZ["MainBar"].y = (DCoordsMainBar:GetTop() - DCoordsMainBar:GetHeight());
    end
    

    log(    "DCoords: Drag finished: x:" .. DCoordsDBZ["MainBar"].x .. "   y:" .. DCoordsDBZ["MainBar"].y  );
    log(    "DCoords: Drag finished: Left:" .. DCoordsGVar["DCMainBar"]:GetLeft() .. "   Top:" .. DCoordsGVar["DCMainBar"]:GetTop()  );
        

    DCoordsMainBar:StopMovingOrSizing()
    mainBarSetFont();
    mainBarSetPosition();
    

    --log("DCoords: Drag complete!");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetPosition()
    local rx = math.floor(DCoordsDBZ["MainBar"].x);
    local ry = math.floor(DCoordsDBZ["MainBar"].y);

    local selectedAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["MainBar"].alignmentIndex ];
    DCoordsGVar["DCMainBar"]:ClearAllPoints();
    DCoordsGVar["DCMainBar"]:SetPoint(selectedAlignment,DCoordsDBZ["MainBar"].x,DCoordsDBZ["MainBar"].y);
    DCoordsGVar["DCMainBarText"]:SetJustifyH("LEFT");
    
    log("mainBarSetPosition(): selectedAlignment = " .. selectedAlignment);
    log("mainBarSetPosition(): x:" .. rx .. " y:" .. ry );
    log("mainBarSetPosition(): Left:" .. DCoordsGVar["DCMainBar"]:GetLeft() .. "   Top:" .. DCoordsGVar["DCMainBar"]:GetTop()  );
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- http://wowprogramming.com/docs/widgets/Frame
-- http://wowprogramming.com/docs/widgets/Region/SetPoint
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local oldAlignment = "";
function mainBarSetFrameAlignment()
    
    --[[
	local frameW = DCoordsGVar["DCMainBarText"]:GetStringWidth() + DCoordsDBZ["MainBar"].paddingLeftRight;
	local frameH = DCoordsGVar["DCMainBarText"]:GetStringHeight() + DCoordsDBZ["MainBar"].paddingTopBottom;
	DCoordsGVar["DCMainBar"]:SetWidth(frameW);
	DCoordsGVar["DCMainBar"]:SetHeight(frameH);
    --]]    
    
    local selectedAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["MainBar"].alignmentIndex ];
    if (oldAlignment ~= selectedAlignment) then
        log("mainBarSetFrameAlignment()");
        DCoordsGVar["DCMainBarText"]:SetText("DCoords updating!");
        
        oldAlignment = selectedAlignment;
        log("mainBarSetFrameAlignment(): selectedAlignment = " .. selectedAlignment);
        DCoordsGVar["DCMainBar"]:ClearAllPoints();
        DCoordsGVar["DCMainBar"]:SetPoint(selectedAlignment,DCoordsDBZ["MainBar"].x,DCoordsDBZ["MainBar"].y);
        DCoordsGVar["DCMainBarText"]:SetJustifyH("LEFT");
    end
    
    --mainBarSetPosition();
    --mainBarSetBackground();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarMouseUpHandler(self,buttonIdentifier)
    log("mainBarMouseUpHandler(self,buttonIdentifier:"..buttonIdentifier..")");
	if (buttonIdentifier == "RightButton") then
		showOptions();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetVisibility()
    log("mainBarSetVisibility(): " .. tostring(DCoordsDBZ["MainBar"].visible) );

    if (DCoordsDBZ["MainBar"].visible) then
		DCoordsGVar["DCMainBar"]:Show();
	else
		DCoordsGVar["DCMainBar"]:Hide();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetBackground()
    log("mainBarSetBackground()");

    if (DCoordsDBZ["MainBar"].bgVisible) then
		if (DCoordsDBZ["MainBar"].bgSelectedIndex == 1) then
        
		    DCoordsGVar["DCMainBar"].texture:SetColorTexture(1,0,0,0);
            
            local tileSize = 10;
            local edgeSize = 10;
            local insets = 3;
            
            DCoordsGVar["DCMainBar"]:SetBackdrop(nil); -- Hide/Remove classic frame
			DCoordsGVar["DCMainBar"]:SetBackdrop({
				bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
				edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
				tile = true, tileSize = tileSize, edgeSize = edgeSize,
				insets = { left = insets, right = insets, top = insets, bottom = insets }
			})
		else
			DCoordsGVar["DCMainBar"]:SetBackdrop(nil); -- Hide/Remove classic frame
            
      
			DCoordsGVar["DCMainBar"].texture:SetColorTexture(
				DCoordsDBZ["MainBar"].bgR,
				DCoordsDBZ["MainBar"].bgG,
				DCoordsDBZ["MainBar"].bgB,
				DCoordsDBZ["MainBar"].bgA
			);
			DCoordsGVar["DCMainBar"].texture:SetAllPoints(true);
		end
	else
		DCoordsGVar["DCMainBar"].texture:SetColorTexture(1,1,0,0);
        DCoordsGVar["DCMainBar"].texture:SetAllPoints(true);
        DCoordsGVar["DCMainBar"]:SetBackdrop(nil); -- Hide/Remove classic frame
	end
    
    local frameW = DCoordsGVar["DCMainBarText"]:GetStringWidth() + DCoordsDBZ["MainBar"].paddingLeftRight;
	local frameH = DCoordsGVar["DCMainBarText"]:GetStringHeight() + DCoordsDBZ["MainBar"].paddingTopBottom;
    DCoordsGVar["DCMainBar"]:SetWidth(frameW);
	DCoordsGVar["DCMainBar"]:SetHeight(frameH);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateBoxBgColor()
    log("updateBoxBgColor()");

    if (DCoordsDBZ["MainBar"].bgVisible == true and DCoordsDBZ["MainBar"].bgSelectedIndex == 2) then
        --log("updateBoxBgColor()");
        DCoordsGVar["DCMainBar"].texture:SetColorTexture(
			DCoordsDBZ["MainBar"].bgR,
			DCoordsDBZ["MainBar"].bgG,
			DCoordsDBZ["MainBar"].bgB,
			DCoordsDBZ["MainBar"].bgA
	    );
    end

    
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #















-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetFont()
    log("mainBarSetFont()");
    
    DCoordsGVar["DCMainBarText"]:SetTextColor(
        DCoordsDBZ["MainBar"].fontR,
        DCoordsDBZ["MainBar"].fontG,
        DCoordsDBZ["MainBar"].fontB,
        DCoordsDBZ["MainBar"].fontA
    );
    
    
    DCoordsGVar["DCMainBarText"]:SetFont(getMainFrameFont(), DCoordsDBZ["MainBar"].fontSize,"OUTLINE");
    
    local textAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["MainBar"].fontAlignmentIndex ];
    local textJustification = DCoordsGVar["JustificationOptions"][ DCoordsDBZ["MainBar"].fontSelectedJustificationIndex ];
    local ox = DCoordsDBZ["MainBar"].fontOffsetX;
    local oy = DCoordsDBZ["MainBar"].fontOffsetY;
    --log("mainBarSetFont(): textAlignment = " .. textAlignment);
    --log("mainBarSetFont(): textJustification = " .. textJustification);
    
    DCoordsGVar["DCMainBarText"]:ClearAllPoints();
    DCoordsGVar["DCMainBarText"]:SetPoint(textJustification,ox,oy);
    
    DCoordsGVar["DCMainBarText"]:SetJustifyH(textJustification);
    
    --DCoordsGVar["DCMainBarText"]:SetPoint("LEFT", WorldFrame, "LEFT", 0,0);
    --DCoordsGVar["DCMainBarText"]:SetPoint(textAlignment,DCoordsDBZ["MainBar"].fontOffsetX,DCoordsDBZ["MainBar"].fontOffsetY);
    
    
    --[[
    --DCoordsGVar["DCMainBarText"]:SetJustifyH("LEFT");
    --]]
    
    --DCoordsGVar["DCMainBarText"]:SetText("Darcey@AllForTheCode.co.uk");
    
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
