--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


local frame;

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMap()
	DCoordsGVar["DCOptions"].Map = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	frame = DCoordsGVar["DCOptions"].Map; 
	frame.name = "World map";
	frame.parent = DCoordsGVar["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"World map");
	
	
	
	setupWorldMapLeft();
	setupWorldMapRight();
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupWorldMapLeft()

	-- Vars
	local msg = "";
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	--createLabel(name,frameContainer,text,size,justify,x,y)
	
	
	
	
	--DCoordsDBZ["MainBar"].visible
	local function cbWorldMapVisibleClickHandler(ticked)
		DCoordsDBZ["WorldMap"].visible = ticked;
		worldMapSetVisibility();
	end
	createCheckbox("cbWorldMapVisible",frame,"World map coordinates visible",DCoordsDBZ["WorldMap"].visible,px,py,cbWorldMapVisibleClickHandler);
	py = py - inc;
	
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderMapFontSelection = {};
	sliderMapFontSelection.name = "mapFontSelectedIndex";
	sliderMapFontSelection.frameContainer = frame;
	sliderMapFontSelection.width = sliderWidth;
	sliderMapFontSelection.labels = {};
	for i = 1, 15, 1 do
		sliderMapFontSelection.labels[i] = "World map use Font no' " .. tostring(i);
	end
	sliderMapFontSelection.selected = DCoordsDBZ["WorldMap"].fontSelectedIndex;
	sliderMapFontSelection.x = px;
	sliderMapFontSelection.y = py;
	sliderMapFontSelection.changeHandler = function(v)
		DCoordsDBZ["WorldMap"].fontSelectedIndex = v;
		worldMapSetFont();
	end;
	createSliderDropReplacement(sliderMapFontSelection);
	py = py - 40;
	
	
	--[[
	--DCoordsDBZ["WorldMap"].fontSelectedIndex
	local function worldMapFontChangeHandler(selectedIndex)
		DCoordsDBZ["WorldMap"].fontSelectedIndex = selectedIndex;
		worldMapSetFont();
	end
	local fontLabels = {}
	for i = 1, 15, 1 do
		fontLabels[i] = "World map coordinates Font no' " .. tostring(i);
	end
	createDropDown("worldMapFontChangeHandler",frame,dropDownWidth,fontLabels,DCoordsDBZ["WorldMap"].fontSelectedIndex,px,py,worldMapFontChangeHandler)
	py = py - 35;
	--]]
	
	
	
			
	--DCoordsDBZ["WorldMap"].fontSize
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontSizeChangeHandler(v)
		if (v == nil) then
			v = 5;
		end
		
		if (v < 0.1) then
			v = 0.1;
		end
	
		DCoordsDBZ["WorldMap"].fontSize = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontSize",frame,5,30,0.1,"World map font size",DCoordsDBZ["WorldMap"].fontSize,sliderWidth,1,px,py,worldMapFontSizeChangeHandler)
	py = py - 60;
	

		
	
	--DCoordsDBZ["WorldMap"].decimalPrecision
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapDecimalPrecisionChangeHandler(v)
		DCoordsDBZ["WorldMap"].decimalPrecision = v;
	end
	createSlider("sWorldMapDecimalPrecision",frame,0,3,1,"World map decimal precision",DCoordsDBZ["WorldMap"].decimalPrecision,sliderWidth,0,px,py,worldMapDecimalPrecisionChangeHandler)
	py = py - 60;
	
	
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderMapFontSelection = {};
	sliderMapFontSelection.name = "mapFontAlignmentIndex";
	sliderMapFontSelection.frameContainer = frame;
	sliderMapFontSelection.width = sliderWidth;
	sliderMapFontSelection.labels = {
		"Align world map coordinates to the TOP",
		"Align world map coordinates to the BOTTOM",
	};
	sliderMapFontSelection.selected = DCoordsDBZ["WorldMap"].fontAlignmentIndex;
	sliderMapFontSelection.x = px;
	sliderMapFontSelection.y = py;
	sliderMapFontSelection.changeHandler = function(v)
		DCoordsDBZ["WorldMap"].fontAlignmentIndex = v;
		worldMapSetPosition();
	end;
	createSliderDropReplacement(sliderMapFontSelection);
	py = py - 40;
	--[[
	--DCoordsDBZ["WorldMap"].fontAlignmentIndex
	local function worldMapAlignmentIndexChangeHandler(selectedIndex)
		DCoordsDBZ["WorldMap"].fontAlignmentIndex = selectedIndex;
		worldMapSetPosition();
	end
	local worldMapAlignmentLabels = {
		"Align text to the TOP",
		"Align text to the BOTTOM"
	};
	createDropDown("worldMapAlignmentIndex",frame,dropDownWidth,worldMapAlignmentLabels,DCoordsDBZ["WorldMap"].fontAlignmentIndex,px,py,worldMapAlignmentIndexChangeHandler)
	py = py - 34;
	--]]
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "TOP ALIGNED: " .. "Best to set offset Y to values 0 to -50." .. "\n\n";
	local info11 = createLabel("DCWorldMapText1",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 20;
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "BOTTOM ALIGNED: " .. "Best to set offset Y to values 0 to +50." .. "\n\n";
	local info11 = createLabel("DCWorldMapText2",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 25;
	
	
	
	
		
	--DCoordsDBZ["WorldMap"].fontSize
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontOffsetYChangeHandler(v)
		DCoordsDBZ["WorldMap"].fontOffsetY = v;
		worldMapSetPosition();
	end
	createSlider("worldMapFontOffsetYChangeHandler",frame,-50,50,0.1,"World map font offset Y",DCoordsDBZ["WorldMap"].fontOffsetY,sliderWidth,1,px,py,worldMapFontOffsetYChangeHandler)
	py = py - 70;
	
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupWorldMapRight()

	-- Vars
	local msg = "";
	local px = 330;
	local py = -84;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "World map coordinates text color (RGBA)." .. "\n\n";
	createLabel("WorldMapColorInfo1",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 18;
	
	local worldMapRGBASliderW = 80;
	
	
	--DCoordsDBZ["WorldMap"].fontR
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontRChangeHandler(v)
		DCoordsDBZ["WorldMap"].fontR = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontR",frame,0,1,0.1,"Red (RGB)",DCoordsDBZ["WorldMap"].fontR,worldMapRGBASliderW-10,1,px,py,worldMapFontRChangeHandler)
	
	
	--DCoordsDBZ["WorldMap"].fontG
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontGChangeHandler(v)
		DCoordsDBZ["WorldMap"].fontG = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontG",frame,0,1,0.1,"Green (RGB)",DCoordsDBZ["WorldMap"].fontG,worldMapRGBASliderW-10,1,px+(worldMapRGBASliderW),py,worldMapFontGChangeHandler)
	
	
	--DCoordsDBZ["WorldMap"].fontB
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontBChangeHandler(v)
		DCoordsDBZ["WorldMap"].fontB = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontB",frame,0,1,0.1,"Blue (RGB)",DCoordsDBZ["WorldMap"].fontB,worldMapRGBASliderW-10,1,px+(worldMapRGBASliderW*2),py,worldMapFontBChangeHandler)
	py = py - 40;
	
	
	--DCoordsDBZ["WorldMap"].fontA
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontAChangeHandler(v)
		DCoordsDBZ["WorldMap"].fontA = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontA",frame,0,1,0.1,"Alpha",DCoordsDBZ["WorldMap"].fontA,worldMapRGBASliderW-10,1,px,py,worldMapFontAChangeHandler)
	py = py - 40;
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
