--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMinimap()
	DCoordsGVar["DCOptions"].Minimap = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	local frame = DCoordsGVar["DCOptions"].Minimap; 
	frame.name = "Minimap";
	frame.parent = DCoordsGVar["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Minimap");
	
	
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 200;
	local sliderWidth = 200;
	local msg = "";
	
	
	-- ensure variables are available
	if (DCoordsDBZ["MinimapLocationBar"] == nil) then
		log("DCoordsDBZ[MinimapLocationBar] WAS NULL- FULL INIT OF OBJECT! AND params!");
		DCoordsDBZ["MinimapLocationBar"] = {};
		DCoordsDBZ["MinimapLocationBar"].showLocationBar = false;
		DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled = true;
		DCoordsDBZ["MinimapLocationBar"].decimalPrecision = 2;
		DCoordsDBZ["MinimapLocationBar"].displayZone = false;
		DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex = 1;
		DCoordsDBZ["MinimapLocationBar"].fontSize = 16;
		DCoordsDBZ["MinimapLocationBar"].fontR = 1;
		DCoordsDBZ["MinimapLocationBar"].fontG = 1;
		DCoordsDBZ["MinimapLocationBar"].fontB = 1;
		DCoordsDBZ["MinimapLocationBar"].fontA = 1;
	end
	if (DCoordsDBZ["MinimapLocationBar"].showLocationBar == nil) then
		DCoordsDBZ["MinimapLocationBar"].showLocationBar = true;
		log("Minimap.showLocationBar WAS NULL- setting to true!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled == nil) then
		DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled = true;
		log("Minimap.coordinatesEnabled WAS NULL- setting to true!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].decimalPrecision == nil) then
		DCoordsDBZ["MinimapLocationBar"].decimalPrecision = 2;
		log("Minimap.decimalPrecision WAS NULL- setting to 2!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].displayZone == nil) then
		DCoordsDBZ["MinimapLocationBar"].displayZone = false;
		log("Minimap.displayZone WAS NULL- setting to false!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex == nil) then
		DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex = 1;
		log("Minimap.fontSelectedIndex WAS NULL- setting to 1!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].fontSize == nil) then
		DCoordsDBZ["MinimapLocationBar"].fontSize = 16;
		log("Minimap.fontSize WAS NULL- setting to 16!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].fontR == nil) then
		DCoordsDBZ["MinimapLocationBar"].fontR = 1;
		log("Minimap.fontR WAS NULL- setting to 1!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].fontG == nil) then
		DCoordsDBZ["MinimapLocationBar"].fontG = 1;
		log("Minimap.fontG WAS NULL- setting to 1!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].fontB == nil) then
		DCoordsDBZ["MinimapLocationBar"].fontB = 1;
		log("Minimap.fontB WAS NULL- setting to 1!");
	end
	if (DCoordsDBZ["MinimapLocationBar"].fontA == nil) then
		DCoordsDBZ["MinimapLocationBar"].fontA = 1;
		log("Minimap.fontA WAS NULL- setting to 1!");
	end
	

	
	
	
	
	local function cbShowLocationBarClickHandler(ticked)
		log("cbMinimapHideLocalBarClickHandler(): Minimap.showLocationBar set to " .. tostring(ticked) );
		DCoordsDBZ["MinimapLocationBar"].showLocationBar = ticked;
		minimapSetFont();
		minimapSetVisibility();
	end
	createCheckbox("cbShowLocationBar",frame,"Show minimap location bar",DCoordsDBZ["MinimapLocationBar"].showLocationBar,px,py,cbShowLocationBarClickHandler);
	py = py - 46;
	
	
	
	
	local function cbMnimapCoordinatesEnabledClickHandler(ticked)
		DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled = ticked;
		log("cbMnimapCoordinatesEnabledClickHandler(): Minimap.coordinatesEnabled set to " .. tostring(ticked) );
		minimapSetFont();
		minimapSetVisibility();
		
		if (ticked == false) then
			PlaySound("LEVELUPSOUND");
    		ReloadUI();
		end
	end
	createCheckbox("cbMinimapCoordinates",frame,"Show minimap coordinates",DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled,px,py,cbMnimapCoordinatesEnabledClickHandler);
	py = py - 20;
	
	msg = "";
	msg = msg .. "WARNING: Disabling this will cause a UI Reload!";
	local info11 = createLabel("DCWorldMapText1",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 46;
	
	
	
	
	local function cbDisplayZoneClickHandler(ticked)
		log("cbDisplayZoneClickHandler(): Minimap.displayZone set to " .. tostring(ticked) );
		DCoordsDBZ["MinimapLocationBar"].displayZone = ticked;
	end
	createCheckbox("cbDisplayZone",frame,"Show minimap zone",DCoordsDBZ["MinimapLocationBar"].displayZone,px,py,cbDisplayZoneClickHandler);
	py = py - 46;
	
	
	
	
	
	
	
	--function createSliderDropReplacement(params)
	local sliderMinimapFontSelection = {};
	sliderMinimapFontSelection.name = "MinimapFontSelectedIndex";
	sliderMinimapFontSelection.frameContainer = frame;
	sliderMinimapFontSelection.width = sliderWidth;
	sliderMinimapFontSelection.labels = {};
	for i = 1, 15, 1 do
		sliderMinimapFontSelection.labels[i] = "Minimap use Font no' " .. tostring(i);
	end
	sliderMinimapFontSelection.selected = DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex;
	sliderMinimapFontSelection.x = px;
	sliderMinimapFontSelection.y = py;
	sliderMinimapFontSelection.changeHandler = function(v)
		DCoordsDBZ["MinimapLocationBar"].fontSelectedIndex = v;
		minimapSetFont();
	end;
	createSliderDropReplacement(sliderMinimapFontSelection);
	py = py - 40;	
	
	
	
	
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function miniMapFontSizeChangeHandler(v)
		if (v == nil) then
			v = 5;
		end
		
		if (v < 9) then
			v = 9;
		end
	
		DCoordsDBZ["MinimapLocationBar"].fontSize = v;
		minimapSetFont();
		minimapSetVisibility();
	end
	createSlider("MinimapFontSize",frame,9,30,0.1,"Minimap font size",DCoordsDBZ["MinimapLocationBar"].fontSize,sliderWidth,1,px,py,miniMapFontSizeChangeHandler)
	py = py - 60;
	
	
	
	
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function miniMapPrecisionChangeHandler(v)
		DCoordsDBZ["MinimapLocationBar"].decimalPrecision = v;
		minimapSetFont();
		minimapSetVisibility();
	end
	createSlider("sliderMiniMapPrecision",frame,0,3,1,"Minimap decimal precision",DCoordsDBZ["MinimapLocationBar"].decimalPrecision,sliderWidth,0,px,py,miniMapPrecisionChangeHandler)
	py = py - 60;
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




